/*******************************************************************
*
*       Simulated Maximum Likelihood estimation of the
*       stochastic volatiliy model
*       version 1.2
*       February, 1996
*
*       Jon Danielsson (c)
*       Department of Economics
*       University of Iceland
*       101 Reykjavik
*       Iceland
*       e-mail: jond@hag.hi.is
*       ftp  hag.hi.is  
*       WWW  http://www.hag.hi.is/~jond
*       
*       please cite in published work and inform the author.
*
******************************************************************/


#include "random.h"

int normal::operator()(double *vv, int n)
{
	int N=n;
	int i;
#ifdef NAG_RAND
	double mmean = 0.0;
	double vvar = 1.0;
	g05fdf(&mmean,&vvar,&N,vv); 
#elif defined(RANLIB)
	for(i=1;i<=N;i++) vv[i] = gennor(0.0,1.0);
#else
err("invalid options");
#endif
	return 0;
}
void normal::init(int iseed) {
#ifdef NAG_RAND
	g05cbf(&iseed); 
#elif defined(RANLIB)
	char *phrase = new char[100];
	static long i,is1,is2;
	for(i=0;i<100;i++) phrase[i] = '\0';
	sprintf(phrase,"%i",iseed);
	phrtsd(phrase,&is1,&is2);
	setall(is1,is2);
#else
	err("Invalid random number generator specified");}
#endif
}


